// HOW TO IMPLEMENT
// copy #defines and pinModes
// copy setting of S0 and S1 in setup()
// then make a function to read out R, G, B, values
// just use pulseIn(OUT) with different setting for S2 and S3
// R = (!S2)&&(!S3)
// G = (S2)&&(S3)
// B = (!S2)&&(S3)
// write these in ints, preferably a struct
// return as function

#define S0 15
#define S1 14
#define S2 38
#define S3 41
#define OUT 40


void setup(void)
{
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(OUT, INPUT);
  Serial.begin(9600);
  while((!Serial) && (millis() < 2000)){}

  digitalWrite(S0, HIGH); // S0 and S1 serve as scaling parameters (this combination is 20%)
  digitalWrite(S1, LOW);
}

void loop (void)
{
  // digitalWrite(S2, HIGH);
  // digitalWrite(S3, HIGH);
  // delay(1000);
  // digitalWrite(S2, LOW);
  // digitalWrite(S3, LOW);
  // delay(1000);

  Serial.print("r = ");
  Serial.print(red());
  delay(10);
  Serial.print("   g = ");
  Serial.print(green());
  delay(10);
  Serial.print("   b = ");
  Serial.println(blue());
  delay(10);

}

int red(void)
{
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
  return pulseIn(OUT, LOW);
}

int green(void)
{
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);
  return pulseIn(OUT, LOW);
}

int blue(void)
{
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  return pulseIn(OUT, LOW);
}