//-----------------DONE----------------//
// test out Rear Panel LEDs 
// test out Rear Panel buttons

//-----------------TODO----------------//
// add parallel resis tor for BUT1
// test out Rear Panel LCD - SCL, SDA on 0x27

//------------I2C ADDRESSES------------//
// 0x27 = LCD
// 0x28 = BNO055

#include <Wire.h>
#include <hd44780.h>
#include <hd44780ioClass/hd44780_I2Cexp.h> // include I2C expander class for hd44780

// define rear panel pins
#define IND1 35
#define IND2 34
#define IND4 32
#define BUT1 28
#define BUT2 29 // plus i2c for display

// define ToF pins (numbers based on PCB order)
#define TOF1 0
#define TOF2 1
#define TOF3 2
#define TOF4 3
#define TOF5 4
#define TOF6 5
#define TOF7 6
#define TOF8 7
#define TOF9 8


hd44780_I2Cexp lcd;

const int waittime = 250;

void setup(void)
{
  // rear panel pinModes
  pinMode(IND1, OUTPUT);
  pinMode(IND2, OUTPUT);
  pinMode(IND4, OUTPUT);
  pinMode(BUT1, INPUT);
  pinMode(BUT2, INPUT);
  
  // communication setup
  while (!Serial && (millis() < 2000)) {} // IMPORTANT!!! If not connected to Serial Teensy will hang forever, here its waiting for 5 seconds
  Serial.begin(115200);
  Wire.begin();
  Wire.setClock(400000); // use 400kHz I2C

  lcd.begin(16, 2);
  lcd.print(">:)");
}

void loop(void)
{

  // REAR PANEL
  // digitalWrite(IND1, HIGH);
  // delay(waittime);
  // digitalWrite(IND1, LOW);
  // digitalWrite(IND2, HIGH);
  // delay(waittime);
  // digitalWrite(IND2, LOW);
  // digitalWrite(IND4, HIGH);
  // delay(waittime);
  // digitalWrite(IND4, LOW);

  // Serial.println(digitalRead(BUT1));
  // delay(waittime/2);
  // Serial.println(digitalRead(BUT2));
  // delay(waittime/2);
  // lcd.print(">:)");
  // Serial.println(">:)");
  // delay(waittime/2);
}